<i18n>
{
  "fr": {
    "title-emfa": "Facteurs d'émissions",
    "text-emfa-file": "Les fichiers suivant décrivent l'ensemble des choix effectués par <em>Labos 1point5</em> : <a class='link' target='_blank' href='/static/carbon/FacteursEmission_GES1point5_Juin2021.pdf'> <span class='icon is-small'><i class='sui sui-file-pdf-o'></i></span> Facteurs d'emission - version de juin 2021</a> et <a class='link' target='_blank' href='/static/carbon/FacteursEmission_BiensEtServices_janvier2022_FR.pdf'> <span class='icon is-small'><i class='sui sui-file-pdf-o'></i></span> Facteurs d'emission biens et services - version de janvier 2022</a>",
    "purchases-ef": "L’intégralité des facteurs d'émissions du module « achats » sont disponibles sous demande auprès d’André Estevez-Torres (<a href='mailto:andre.estevez-torres@upmc.fr'>andre.estevez-torres@upmc.fr</a>) et Olivier Aumont (<a href='mailto:olivier.aumont@ird.fr'>olivier.aumont@ird.fr</a>). Ils seront publiquement disponibles dans quelques mois, dès qu’on aura trouvé une licence adaptée pour leur distribution."
  },
  "en": {
    "title-emfa": "Emission factors",
    "text-emfa-file": "The emission factors posted below are specific to research institutions located in France (including the overseas territories). These factors must be customised to the country where the research institutions are located, as they rely on specific local conditions, such as the fuel mix of the generation of electricity, the fuel mix of the district heating systems, the origin of the fuel supplies, the energy efficiency of the vehicle fleets, the traffic level, ...",
    "purchases-ef": "The full set of emission factors for the « purchases » module are available upon request from André Estevez-Torres (<a href='mailto:andre.estevez-torres@upmc.fr'>andre.estevez-torres@upmc.fr</a>) and Olivier Aumont (<a href='mailto:olivier.aumont@ird.fr'>olivier.aumont@ird.fr</a>). They will be publicly available in a few months, as soon as we find a suitable license for their distribution."
  }
}
</i18n>

<template>
  <div>
    <su-service :icon="'cloud'">
      <template #title>
        {{ $t('title-emfa') }}
      </template>
      <span v-html="$t('text-emfa-file')" />.
    </su-service>
    <br/>
    <b-tabs
      :animated="false"
      v-model="activeTab"
      style="position:absolute;left:0;right:0;margin-top:30px"
      >
      <b-tab-item icon="car" value="vehicles" :label="$t('vehicles')">
        <emissions-factors-table v-if="activeTab==='vehicles'" :factors="vehiclesFactors" class="overflowcontent" />
      </b-tab-item>
      <b-tab-item icon="train" value="transports" :label="$t('transports')">
        <emissions-factors-table v-if="activeTab==='transports'" :factors="transportsFactors" class="overflowcontent" />
      </b-tab-item>
      <b-tab-item icon="thermometer-full" value="heating" :label="$t('heating')">
        <emissions-factors-table v-if="activeTab==='heating'" :factors="heatingFactors" class="overflowcontent" />
      </b-tab-item>
      <b-tab-item icon="plug" value="electricity" :label="$t('electricity')">
        <emissions-factors-table v-if="activeTab==='electricity'" :factors="electricityFactors" class="overflowcontent" />
      </b-tab-item>
      <b-tab-item icon="snowflake-o" value="refrigerants" :label="$t('refrigerants')">
        <emissions-factors-table v-if="activeTab==='refrigerants'" :factors="refrigerantsFactors" class="overflowcontent" />
      </b-tab-item>
      <b-tab-item icon="eur" value="purchases" :label="$t('purchases')">
        <b-notification :closable="false">
          <span v-html="$t('purchases-ef')" />
        </b-notification>
        <!-- <emissions-factors-table v-if="activeTab==='purchases'" :factors="purchasesFactors" class="overflowcontent" /> -->
      </b-tab-item>
    </b-tabs>
    <div style="margin-top:700px;">
    </div>
  </div>
</template>

<script>
import VEHICLES_FACTORS from '@/../data/vehiclesFactors.json'
import TRANSPORTS_FACTORS from '@/../data/transportsFactors.json'
import HEATING_FACTORS from '@/../data/heatingFactors.json'
import ELECTRICITY_FACTORS from '@/../data/electricityFactors.json'
import REFRIGERANTS_FACTORS from '@/../data/refrigerantsFactors.json'
import PURCHASES_FACTORS from '@/../data/purchasesFactors.json'

export default {
  name: 'EmissionsFactors',
  components: {
    'su-service': () => import('@/components/SUService.vue'),
    'emissions-factors-table': () => import('@/components/carbon/docs/EmissionsFactorsTable.vue')
  },
  data () {
    return {
      activeTab: 'vehicles'
    }
  },
  computed: {
    vehiclesFactors: function () {
      let factors = []
      for (let subcategory of Object.keys(VEHICLES_FACTORS)) {
        for (let subsubcategory of Object.keys(VEHICLES_FACTORS[subcategory])) {
          factors.push({
            category: 'vehicles',
            subcategory: subcategory,
            subsubcategory: subsubcategory,
            description_FR: VEHICLES_FACTORS[subcategory][subsubcategory].description_FR,
            description_EN: VEHICLES_FACTORS[subcategory][subsubcategory].description_EN,
            unit: VEHICLES_FACTORS[subcategory][subsubcategory].unit,
            group: VEHICLES_FACTORS[subcategory][subsubcategory].group,
            decomposition: VEHICLES_FACTORS[subcategory][subsubcategory].decomposition
          })
        }
      }
      return factors
    },
    transportsFactors: function () {
      let factors = []
      for (let subcategory of Object.keys(TRANSPORTS_FACTORS)) {
        for (let subsubcategory of Object.keys(TRANSPORTS_FACTORS[subcategory])) {
          factors.push({
            category: 'transports',
            subcategory: subcategory,
            subsubcategory: subsubcategory,
            description_FR: TRANSPORTS_FACTORS[subcategory][subsubcategory].description_FR,
            description_EN: TRANSPORTS_FACTORS[subcategory][subsubcategory].description_EN,
            unit: TRANSPORTS_FACTORS[subcategory][subsubcategory].unit,
            group: TRANSPORTS_FACTORS[subcategory][subsubcategory].group,
            decomposition: TRANSPORTS_FACTORS[subcategory][subsubcategory].decomposition
          })
        }
      }
      return factors
    },
    heatingFactors: function () {
      let factors = []
      for (let subcategory of Object.keys(HEATING_FACTORS)) {
        for (let subsubcategory of Object.keys(HEATING_FACTORS[subcategory])) {
          let rsubsubcat = subsubcategory
          if (subsubcategory.startsWith('network')) {
            rsubsubcat = HEATING_FACTORS[subcategory][subsubcategory].description_FR
          }
          factors.push({
            category: 'heating',
            subcategory: subcategory,
            subsubcategory: rsubsubcat,
            description_FR: HEATING_FACTORS[subcategory][subsubcategory].description_FR,
            description_EN: HEATING_FACTORS[subcategory][subsubcategory].description_EN,
            unit: HEATING_FACTORS[subcategory][subsubcategory].unit,
            group: HEATING_FACTORS[subcategory][subsubcategory].group,
            decomposition: HEATING_FACTORS[subcategory][subsubcategory].decomposition
          })
        }
      }
      return factors
    },
    electricityFactors: function () {
      let factors = []
      for (let subcategory of Object.keys(ELECTRICITY_FACTORS)) {
        factors.push({
          category: 'electricity',
          subcategory: subcategory,
          subsubcategory: '-',
          description_FR: ELECTRICITY_FACTORS[subcategory].description_FR,
          description_EN: ELECTRICITY_FACTORS[subcategory].description_EN,
          unit: ELECTRICITY_FACTORS[subcategory].unit,
          group: ELECTRICITY_FACTORS[subcategory].group,
          decomposition: ELECTRICITY_FACTORS[subcategory].decomposition
        })
      }
      return factors
    },
    refrigerantsFactors: function () {
      let factors = []
      for (let subcategory of Object.keys(REFRIGERANTS_FACTORS)) {
        factors.push({
          category: 'refrigerants',
          subcategory: REFRIGERANTS_FACTORS[subcategory].description_FR,
          subsubcategory: '-',
          description_FR: REFRIGERANTS_FACTORS[subcategory].description_FR,
          description_EN: REFRIGERANTS_FACTORS[subcategory].description_EN,
          unit: REFRIGERANTS_FACTORS[subcategory].unit,
          group: REFRIGERANTS_FACTORS[subcategory].group,
          decomposition: REFRIGERANTS_FACTORS[subcategory].decomposition
        })
      }
      return factors
    },
    purchasesFactors: function () {
      let factors = []
      for (let subcategory of Object.keys(PURCHASES_FACTORS)) {
        factors.push({
          category: 'purchases',
          subcategory: PURCHASES_FACTORS[subcategory].category,
          subsubcategory: subcategory.toUpperCase(),
          description_FR: PURCHASES_FACTORS[subcategory].description_FR,
          description_EN: PURCHASES_FACTORS[subcategory].description_FR,
          unit: PURCHASES_FACTORS[subcategory].unit,
          group: PURCHASES_FACTORS[subcategory].group,
          decomposition: PURCHASES_FACTORS[subcategory].decomposition
        })
      }
      return factors
    }
  },
  methods: {
    hasDecomposition: function (row) {
      return (Object.keys(row.decomposition).length > 1)
    }
  }
}
</script>

<style>
.overflowcontent {
  position:absolute;
  left:0;
  right:0;
  overflow-y:auto;
  overflow-x:hidden;
  height:560px;
  margin-top:30px;
}
</style>
